;;;;;;;;;;;
;;Tests 2;;
;;;;;;;;;;;

;;loading necessary files
(load "problems2.scm")
(load "tester-utils.scm")


;;starting test
(begin-test-suite)

(begin

  ;;contains
  (test 1 '(contains? '() 3) #f)
  (test 1 '(contains? (list 1 2 3) 2) #t)
  (test 1 '(contains? (list 1 (list 2) 3) 2) #f)
  (test 1 '(contains? (list 1 (list 2) 3) 3) #t)
  (test 1 '(contains? (list 7 5 3 (list 1 9)) 8) #f)
  (test 1 '(contains? (list 5 6 2 (list 7 0)) 5) #t)
  (test 1 '(contains? (list 0 6 1 (list 5 1)) 1) #t)
  (test 1 '(contains? (list 0 4 5 (list 7 4)) 5) #t)
  (test 1 '(contains? (list 8 9 2 (list 5 9)) 8) #t)
  
  ;;remove duplicates
  (test 1 '(remove-duplicates (list 1 2 3 1 2 3)) '(1 2 3))
  (test 1 '(remove-duplicates (list 1 1 1 1 1 1)) '(1))
  (test 1 '(remove-duplicates (list 1 1 1 2 2 2)) '(1 2))
  (test 1 '(remove-duplicates (list 1 2 3 4)) '(1 2 3 4))
  (test 1 '(remove-duplicates '()) '())
  (test-multiple-answers 1 '(remove-duplicates (list 3 1 3 1 2 1 0 1 0 3)) '((2 1 0 3) (3 1 2 0)))
  (test-multiple-answers 1 '(remove-duplicates (list 4 2 1 4 0 3 0 3 0 2)) '((1 4 3 0 2) '(4 2 1 0 3)))
  (test-multiple-answers 1 '(remove-duplicates (list 1 2 4 4 4 1 0 1 4 0)) '((2 1 4 0) (1 2 4 0)))
  
  ;;union
  (test-multiple-answers 1 '(union (list 1 2 3) (list 5 3 2 1)) '((1 2 3 5) (5 3 2 1)))
  (test-multiple-answers 1 '(union (list 1 2 3) (list 2 4 6)) '((1 2 3 4 6) (1 3 2 4 6)))
  (test 1 '(union '() (list 3 4 5)) '(3 4 5))
  (test 1 '(union (list 4 3 2) '()) '(4 3 2))
  
  ;;subset
  (test 1 '(subset? (list 1 2 3) (list 5 3 2 1)) #t)
  (test 1 '(subset? (list 1 2 3) (list 2 4 6)) #f)
  (test 1 '(subset? '() (list 3 4 5)) #t)
  (test 1 '(subset? (list 1 2 3) (list 5 4 3 2 1)) #t)
  (test 1 '(subset? (list 1) '()) #f)
  (test 1 '(subset? (list 1) (list 2 1)) #t)
  (test 1 '(subset? (remove-duplicates (list 1 3 2 0)) (remove-duplicates (list 4 2 1 3 1 0))) #t)
  (test 1 '(subset? (remove-duplicates (list 3 2 0 0)) (remove-duplicates (list 2 1 4 3 2 4))) #f)
  (test 1 '(subset? (remove-duplicates (list 3 1 2 3)) (remove-duplicates (list 4 4 3 2 4 1))) #t)
  (test 1 '(subset? (remove-duplicates (list 4 1 3 0)) (remove-duplicates (list 0 2 2 0 2 4))) #f)
  (test 1 '(subset? (remove-duplicates (list 1 4 0 1)) (remove-duplicates (list 1 2 0 1 0 2))) #f)
  
  (end-test-suite))